﻿Imports Steema.TeeChart.Styles
Imports Steema.TeeChart

Public Class Form1

    Private tChart As New Steema.TeeChart.TChart

    Public Sub InitializeChart()


        Dim HeaderText(0) As String
        HeaderText(0) = "Min Max Errorbar"

        Dim Marktips As New Steema.TeeChart.Tools.MarksTip(tChart.Chart)
        Marktips.HideDelay = 3000
        Marktips.MouseDelay = 10
        Marktips.MouseAction = Tools.MarksTipMouseAction.Click
        Marktips.Active = True
        tChart.Tools.Add(Marktips)

        ' Set aspect of chart
        tChart.Aspect.View3D = False
        tChart.Aspect.Orthogonal = True
        tChart.Aspect.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias
        tChart.Aspect.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias
        tChart.Aspect.Zoom = 100

        ' set default setting of axes

        tChart.Axes.Depth.Visible = False
        tChart.Axes.Depth.Grid.ZPosition = 0
        tChart.Axes.Depth.Labels.Font.Shadow.Visible = False
        tChart.Axes.Depth.Labels.Shadow.Visible = False
        tChart.Axes.Depth.Title.Font.Shadow.Visible = False
        tChart.Axes.Depth.Title.Shadow.Visible = False

        tChart.Axes.DepthTop.Visible = False
        tChart.Axes.DepthTop.Grid.ZPosition = 0
        tChart.Axes.DepthTop.Labels.Font.Shadow.Visible = False
        tChart.Axes.DepthTop.Labels.Shadow.Visible = False
        tChart.Axes.DepthTop.Title.Font.Shadow.Visible = False
        tChart.Axes.DepthTop.Title.Shadow.Visible = False

        tChart.Axes.Bottom.Automatic = True
        tChart.Axes.Bottom.AxisPen.Width = 2
        tChart.Axes.Bottom.Grid.Visible = False
        tChart.Axes.Bottom.Grid.ZPosition = 0
        tChart.Axes.Bottom.Labels.Font.Shadow.Visible = False
        tChart.Axes.Bottom.Labels.Font.Size = 11
        tChart.Axes.Bottom.Labels.Shadow.Visible = False
        tChart.Axes.Bottom.Title.Font.Shadow.Visible = False
        tChart.Axes.Bottom.Title.Lines = Nothing
        tChart.Axes.Bottom.Title.Angle = 90
        tChart.Axes.Bottom.Title.Shadow.Visible = False
        tChart.Axes.Bottom.MinorTicks.Color = Color.Black
        tChart.Axes.Bottom.MinorTickCount = 4
        tChart.Axes.Bottom.MinorTicks.Width = 2
        tChart.Axes.Bottom.MinorTicks.Length = 2.5
        tChart.Axes.Bottom.Ticks.Color = Color.Black
        tChart.Axes.Bottom.Ticks.Length = 5
        tChart.Axes.Bottom.Ticks.Width = 2
        tChart.Axes.Bottom.Title.Font.Size = 11


        tChart.Axes.Left.Automatic = True
        tChart.Axes.Left.AxisPen.Width = 2
        tChart.Axes.Left.Grid.Visible = False
        tChart.Axes.Left.Grid.ZPosition = 0
        tChart.Axes.Left.Labels.Font.Shadow.Visible = False
        tChart.Axes.Left.Labels.Font.Size = 11
        tChart.Axes.Left.Labels.Shadow.Visible = False
        tChart.Axes.Left.Title.Font.Shadow.Visible = False
        tChart.Axes.Left.Title.Lines = Nothing
        tChart.Axes.Left.Title.Angle = 90
        tChart.Axes.Left.Title.Shadow.Visible = False
        tChart.Axes.Left.MinorTicks.Color = Color.Black
        tChart.Axes.Left.MinorTickCount = 4
        tChart.Axes.Left.MinorTicks.Width = 2
        tChart.Axes.Left.MinorTicks.Length = 2.5
        tChart.Axes.Left.Ticks.Length = 5
        tChart.Axes.Left.Ticks.Width = 2
        tChart.Axes.Left.Ticks.Color = Color.Black
        tChart.Axes.Left.Title.Font.Size = 11


        tChart.Axes.Right.Visible = False
        tChart.Axes.Right.Automatic = True
        tChart.Axes.Right.AxisPen.Width = 2
        tChart.Axes.Right.Grid.Visible = False
        tChart.Axes.Right.Grid.ZPosition = 0
        tChart.Axes.Right.Labels.Font.Shadow.Visible = False
        tChart.Axes.Right.Labels.Font.Size = 11
        tChart.Axes.Right.Labels.Shadow.Visible = False
        tChart.Axes.Right.Title.Font.Shadow.Visible = False
        tChart.Axes.Right.Title.Shadow.Visible = False
        tChart.Axes.Right.MinorTicks.Color = Color.Black
        tChart.Axes.Right.MinorTickCount = 4
        tChart.Axes.Right.MinorTicks.Width = 2
        tChart.Axes.Right.MinorTicks.Length = 2.5
        tChart.Axes.Right.Ticks.Length = 5
        tChart.Axes.Right.Ticks.Width = 2
        tChart.Axes.Right.Ticks.Color = Color.Black
        tChart.Axes.Right.Title.Font.Size = 11

        tChart.Axes.Top.Visible = False
        tChart.Axes.Top.Automatic = True
        tChart.Axes.Top.AxisPen.Width = 2
        tChart.Axes.Top.Grid.Visible = False
        tChart.Axes.Top.Grid.ZPosition = 0
        tChart.Axes.Top.Labels.Font.Shadow.Visible = False
        tChart.Axes.Top.Labels.Font.Size = 11
        tChart.Axes.Top.Labels.Shadow.Visible = False
        tChart.Axes.Top.Title.Font.Shadow.Visible = False
        tChart.Axes.Top.Title.Shadow.Visible = False
        tChart.Axes.Top.MinorTicks.Color = Color.Black
        tChart.Axes.Top.MinorTickCount = 4
        tChart.Axes.Top.MinorTicks.Width = 2
        tChart.Axes.Top.MinorTicks.Length = 2.5
        tChart.Axes.Top.Ticks.Length = 5
        tChart.Axes.Top.Ticks.Width = 2
        tChart.Axes.Top.Ticks.Color = Color.Black
        tChart.Axes.Top.Title.Font.Size = 11

        tChart.Footer.Font.Shadow.Visible = False
        tChart.Footer.Shadow.Visible = False

        tChart.Header.Font.Bold = True
        tChart.Header.Font.Size = 12
        tChart.Header.Font.Brush.Color = System.Drawing.Color.Black
        tChart.Header.Font.Shadow.Visible = False
        tChart.Header.Lines = HeaderText
        tChart.Header.Shadow.Visible = False
        tChart.Header.Text = "Min Max ErrorBar"

        tChart.Legend.Font.Shadow.Visible = False
        tChart.Legend.Title.Font.Bold = True
        tChart.Legend.Title.Font.Shadow.Visible = False
        tChart.Legend.Title.Pen.Visible = False
        tChart.Legend.Title.Shadow.Visible = False
        tChart.Legend.Shadow.Visible = False

        tChart.Size = New System.Drawing.Size(490, 360)

        tChart.Panel.Color = System.Drawing.Color.White
        tChart.Panel.ImageBevel.Width = 0
        tChart.Panel.Shadow.Brush.Color = Color.Black
        tChart.Panel.Shadow.Visible = False
        tChart.Panel.Bevel.Outer = Steema.TeeChart.Drawing.BevelStyles.None
        tChart.Panel.Gradient.Visible = False

        tChart.SubFooter.Font.Shadow.Visible = False
        tChart.SubFooter.Shadow.Visible = False
        tChart.SubHeader.Font.Shadow.Visible = False
        tChart.SubHeader.Shadow.Visible = False

        tChart.Walls.Back.Visible = False
        tChart.Walls.Back.Shadow.Visible = False
        tChart.Walls.Bottom.Visible = False
        tChart.Walls.Bottom.Shadow.Visible = False
        tChart.Walls.Left.Visible = False
        tChart.Walls.Left.Shadow.Visible = False
        tChart.Walls.Right.Visible = True
        tChart.Walls.Right.Shadow.Visible = True
        tChart.Walls.Visible = True

        tChart.Axes.Bottom.MaximumOffset = 15
        tChart.Axes.Left.MinimumOffset = 5
        tChart.Axes.Left.MaximumOffset = 5


    End Sub


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load



        ' Initialize chart
        InitializeChart()

        Dim GraphXAxisTitle(2) As String
        GraphXAxisTitle = New String() {"A", "B", "C"}

        Dim GraphData(4, 2) As Double
        GraphData = New Double(,) {{1, 2, 3, 4, 5}, {8, 9, 11, 12, 15}, {22, 19, 21, 23, 17}}

        Dim GraphData_Mean(2) As Double
        GraphData_Mean(0) = 3
        GraphData_Mean(1) = 11
        GraphData_Mean(2) = 34

        Dim GraphData_Max(2) As Double
        GraphData_Max(0) = 5
        GraphData_Max(1) = 15
        GraphData_Max(2) = 23

        Dim GraphData_Min(2) As Double
        GraphData_Min(0) = 1
        GraphData_Min(1) = 8
        GraphData_Min(2) = 17

        ' Clearing  and Setting tchart1 properties
        tChart.Series.Clear()
        tChart.Axes.Bottom.Labels.Items.Clear()

        ' The labels for vertical axis
        Dim Ylabel(0) As String
        Ylabel(0) = "Y Title"
        tChart.Axes.Left.Title.Lines = Ylabel
        tChart.Axes.Left.Title.Text = Ylabel(0)
        tChart.Axes.Left.Title.Visible = True

        ' The labels for the chart
        Dim labels(GraphXAxisTitle.Length - 1) As String
        For i = 0 To GraphXAxisTitle.Length - 1
            labels(i) = GraphXAxisTitle(i)
        Next

        ' Set titles of graph
        tChart.Header.Text = "MinMax ErrorBar"
        tChart.Header.Visible = True
        tChart.Legend.Visible = False


        ' Set Axes

        tChart.Axes.Left.MinorTickCount = 0
        tChart.Axes.Left.Automatic = True
        tChart.Axes.Left.Labels.Font.Size = 11
        tChart.Axes.Bottom.MinorTickCount = 0
        tChart.Axes.Bottom.Automatic = True
        tChart.Axes.Bottom.Labels.Font.Size = 11
        tChart.Axes.Bottom.MinimumOffset = 50
        tChart.Axes.Bottom.MaximumOffset = 50
        tChart.Axes.Left.MinimumOffset = 0

        Dim ErrorbarMin As New Steema.TeeChart.Styles.Error()
        Dim ErrorbarMax As New Steema.TeeChart.Styles.Error()

        For i = 0 To 2

            tChart.Series.Add(New Steema.TeeChart.Styles.Bar(tChart.Chart))
            Dim bar As Steema.TeeChart.Styles.Bar = tChart.Series(i)

            bar.Pen.Color = Color.Black
            bar.Pen.Width = 2
            bar.Brush.Solid = True
            bar.Brush.Color = Color.White
            bar.Title = labels(i)
            bar.Marks.Visible = False
            bar.XValues.DataMember = "X"
            bar.XValues.Order = Steema.TeeChart.Styles.ValueListOrder.None
            bar.YValues.DataMember = "Bar"

            bar.MultiBar = MultiBars.None
            bar.BarWidthPercent = 40

            tChart.Axes.Bottom.Labels.Items.Add(i, bar.Title)
            bar.Add(i, GraphData_Mean(i), labels(i))

            ErrorbarMax.Add(i, GraphData_Mean(i), GraphData_Max(i) - GraphData_Mean(i), labels(i))
            ErrorbarMin.Add(i, GraphData_Mean(i), GraphData_Mean(i) - GraphData_Min(i), labels(i))

        Next


        ErrorbarMax.Color = Color.Black
        ErrorbarMax.HorizAxis = HorizontalAxis.Bottom
        ErrorbarMax.ErrorPen.Visible = True
        ErrorbarMax.ErrorPen.Width = 2
        ErrorbarMax.ErrorPen.Style = Drawing2D.DashStyle.Solid
        ErrorbarMax.ErrorWidthUnits = ErrorWidthUnits.Percent
        ErrorbarMax.ErrorWidth = 65
        ErrorbarMax.ErrorStyle = ErrorStyles.Top
        ErrorbarMax.Title = "Max bar"
        ErrorbarMax.OffsetPercent = 0

        ErrorbarMin.Color = Color.Black
        ErrorbarMin.HorizAxis = HorizontalAxis.Bottom
        ErrorbarMin.ErrorPen.Visible = True
        ErrorbarMin.ErrorPen.Width = 2
        ErrorbarMin.ErrorPen.Style = Drawing2D.DashStyle.Solid
        ErrorbarMin.ErrorWidthUnits = ErrorWidthUnits.Percent
        ErrorbarMin.ErrorWidth = 65
        ErrorbarMin.ErrorStyle = ErrorStyles.Bottom
        ErrorbarMin.Title = "Min bar"
        ErrorbarMin.OffsetPercent = 0

        tChart.Series.Add(ErrorbarMax)
        tChart.Series.Add(ErrorbarMin)

        tChart.Chart.Tag = "MeanBarError"

        Panel1.Controls.Add(tChart)


    End Sub
End Class
